#ifndef lint
static char rcsid[] = "$Header: /mDNS/qconv/qconv.c 12    01/01/25 11:22 Kato $";
#endif

/*
 * All of the documentation and software included in QCONV is copyrighted
 * by NTT Software Corporation.
 * 
 * Copyright 2000, 2001 NTT Software Corporation.  All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met: 
 * 
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE NTT SOFTWARE ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
 */

#include <windowsx.h>
#include <stdio.h>
//#include <htmlhelp.h>

#include "qconv.h"

HINSTANCE	g_hinst;

void
QCPopupMenu(HWND hDlg, LPARAM lParam)
{
	HMENU	hMenu;				// menu template          
	HMENU	hMenuTrackPopup;	// shortcut menu   
	POINT	pt;
	UINT	encodingId;
	UINT	returnId;
	UINT	iRet;
	UINT	uCheck;

	if (GetCursorPos(&pt) == 0) {
		pt.x = GetSystemMetrics(SM_CXSCREEN);
		pt.y = GetSystemMetrics(SM_CYSCREEN);
	}

	hMenu = LoadMenu(g_hinst, MAKEINTRESOURCE(IDR_MENU));
	if (hMenu == NULL) {
		return;
	}

	encodingId = GetMenuItemForName(id_encoding);
	if (encodingId == IDC_NOMENUITEM) {
		encodingId = IDC_CONV_OTHER;
	}

	hMenuTrackPopup = GetSubMenu(hMenu, 0);

	iRet = CheckMenuItem(hMenuTrackPopup, encodingId, MF_BYCOMMAND | MF_CHECKED);

	uCheck = id_show_main? MF_CHECKED: MF_UNCHECKED;
	iRet = CheckMenuItem(hMenuTrackPopup, IDC_SHOW_MAIN, MF_BYCOMMAND | uCheck);

	uCheck = id_copy_to_clipboard? MF_CHECKED: MF_UNCHECKED;
	iRet = CheckMenuItem(hMenuTrackPopup, IDC_COPY_TO_CB, MF_BYCOMMAND | uCheck);

	uCheck = id_always_on_top? MF_CHECKED: MF_UNCHECKED;
	iRet = CheckMenuItem(hMenuTrackPopup, IDC_ON_TOP, MF_BYCOMMAND | uCheck);

	if (id_on_left_click) {
		iRet = CheckMenuItem(hMenuTrackPopup, IDC_ON_LEFT_CLICK, MF_BYCOMMAND | MF_CHECKED);
		iRet = CheckMenuItem(hMenuTrackPopup, IDC_CONTINUOUS, MF_BYCOMMAND | MF_UNCHECKED);
	}
	else {
		iRet = CheckMenuItem(hMenuTrackPopup, IDC_ON_LEFT_CLICK, MF_BYCOMMAND | MF_UNCHECKED);
		iRet = CheckMenuItem(hMenuTrackPopup, IDC_CONTINUOUS, MF_BYCOMMAND | MF_CHECKED);
	}

	uCheck = id_always_on_top? MF_CHECKED: MF_UNCHECKED;
	iRet = CheckMenuItem(hMenuTrackPopup, IDC_ON_TOP, MF_BYCOMMAND | uCheck);

	returnId = TrackPopupMenu(hMenuTrackPopup,
							  TPM_RIGHTALIGN | TPM_BOTTOMALIGN |
							  TPM_LEFTBUTTON | TPM_RETURNCMD,
							  pt.x, pt.y, 0, hDlg, NULL);

	iRet = SendMessage(hDlg, WM_COMMAND, returnId, (long)NULL);

	iRet = DestroyMenu(hMenu);
}

void
SetSettingDlgItems(HWND hSetDlg)
{
	int		iRet;
	int		i;

	iRet = SendDlgItemMessage(hSetDlg, IDC_INPUT_ENCODE, CB_ADDSTRING,
							  0, (long)id_encoding_local);
	for (i = 0; i < SIZEOF_ENCODING_ETABLE; i++) {
		if (encoding_table[i].flag) {
			iRet = SendDlgItemMessage(hSetDlg, IDC_INPUT_ENCODE, CB_ADDSTRING,
									  0, (long)encoding_table[i].name);
		}
		iRet = SendDlgItemMessage(hSetDlg, IDC_OUTPUT_ENCODE, CB_ADDSTRING,
								  0, (long)encoding_table[i].name);
	}
	iRet = SetDlgItemText(hSetDlg, IDC_INPUT_ENCODE, id_encoding_input);
	iRet = SetDlgItemText(hSetDlg, IDC_OUTPUT_ENCODE, id_encoding);
	if (id_encoding_other[0] != '\0') {
		iRet = SendDlgItemMessage(hSetDlg, IDC_OUTPUT_ENCODE, CB_ADDSTRING,
								  0, (long)id_encoding_other);
	}

	iRet = SendDlgItemMessage(hSetDlg, IDC_ZLD_STRING, CB_ADDSTRING, 0, (long)"idns.net");
	iRet = SendDlgItemMessage(hSetDlg, IDC_ZLD_STRING, CB_ADDSTRING, 0, (long)"utf5");
	iRet = SendDlgItemMessage(hSetDlg, IDC_ZLD_STRING, CB_ADDSTRING, 0, (long)"utf8");

	if ((id_zld[0] != '\0') &&
		(strcmp(id_zld, "idns.net") != 0) &&
		(strcmp(id_zld, "utf8") != 0) &&
		(strcmp(id_zld, "utf5") != 0)) {
		iRet = SendDlgItemMessage(hSetDlg, IDC_ZLD_STRING, CB_ADDSTRING, 0, (long)id_zld);
	}
	iRet = SetDlgItemText(hSetDlg, IDC_ZLD_STRING, id_zld);

	iRet = SetDlgItemInt(hSetDlg, IDC_MAX_MESSAGE_LEN, id_edit_buffer_len, FALSE);

	iRet = CheckDlgButton(hSetDlg, IDC_SHOW_MAIN,
						  id_show_main?		BST_CHECKED: BST_UNCHECKED);
	iRet = CheckDlgButton(hSetDlg, IDC_SET_AUTO_ZLD,
						  id_auto_zld?			BST_CHECKED: BST_UNCHECKED);
	iRet = CheckDlgButton(hSetDlg, IDC_COPY_TO_CB,
						  id_copy_to_clipboard?BST_CHECKED: BST_UNCHECKED);
	iRet = CheckDlgButton(hSetDlg, IDC_ALWAYS_ON_TOP,
						  id_always_on_top?	BST_CHECKED: BST_UNCHECKED);
	iRet = CheckDlgButton(hSetDlg, IDC_RESULT_ONLY,
						  id_result_only?		BST_CHECKED: BST_UNCHECKED);
	iRet = CheckDlgButton(hSetDlg, IDC_RESULT_AND_INPUT,
						  id_result_only?		BST_UNCHECKED: BST_CHECKED);
	iRet = CheckDlgButton(hSetDlg, IDC_HEX_CODE,
						  id_disp_hex_code?	BST_CHECKED: BST_UNCHECKED);
	iRet = CheckDlgButton(hSetDlg, IDC_ON_LEFT_CLICK,
						  id_on_left_click?	BST_CHECKED: BST_UNCHECKED);
	iRet = CheckDlgButton(hSetDlg, IDC_CONTINUOUS,
						  id_on_left_click?	BST_UNCHECKED: BST_CHECKED);
	iRet = CheckDlgButton(hSetDlg, IDC_DISABLE_ERROR,
						  id_disable_error?	BST_CHECKED: BST_UNCHECKED);
}

int
GetSettingDlgItems(HWND hSetDlg)
{
	UINT		uRet;
	int			iRet;
	BOOL		result;

	iRet = GetDlgItemText(hSetDlg, IDC_INPUT_ENCODE, id_encoding_input, MAX_NAME);
	iRet = GetDlgItemText(hSetDlg, IDC_OUTPUT_ENCODE, id_encoding, MAX_NAME);
	if (GetMenuItemForName(id_encoding) == IDC_NOMENUITEM) {
		strcpy(id_encoding_other, id_encoding);
	}

	iRet = GetDlgItemText(hSetDlg, IDC_ZLD_STRING, id_zld, MAX_NAME);

	iRet = GetDlgItemInt(hSetDlg, IDC_MAX_MESSAGE_LEN, &result, FALSE);
	if (result == TRUE) {
		id_edit_buffer_len = iRet;
	}
	uRet = IsDlgButtonChecked(hSetDlg, IDC_SHOW_MAIN);
	id_show_main = (uRet == BST_CHECKED)? TRUE: FALSE;
	uRet = IsDlgButtonChecked(hSetDlg, IDC_SET_AUTO_ZLD);
	id_auto_zld = (uRet == BST_CHECKED)? TRUE: FALSE;
	uRet = IsDlgButtonChecked(hSetDlg, IDC_COPY_TO_CB);
	id_copy_to_clipboard = (uRet == BST_CHECKED)? TRUE: FALSE;
	uRet = IsDlgButtonChecked(hSetDlg, IDC_ALWAYS_ON_TOP);
	id_always_on_top = (uRet == BST_CHECKED)? TRUE: FALSE;
	uRet = IsDlgButtonChecked(hSetDlg, IDC_RESULT_ONLY);
	id_result_only = (uRet == BST_CHECKED)? TRUE: FALSE;
	uRet = IsDlgButtonChecked(hSetDlg, IDC_HEX_CODE);
	id_disp_hex_code = (uRet == BST_CHECKED)? TRUE: FALSE;
	uRet = IsDlgButtonChecked(hSetDlg, IDC_ON_LEFT_CLICK);
	id_on_left_click = (uRet == BST_CHECKED)? TRUE: FALSE;
	uRet = IsDlgButtonChecked(hSetDlg, IDC_DISABLE_ERROR);
	id_disable_error = (uRet == BST_CHECKED)? TRUE: FALSE;

	iRet = InitializeConverter();
	if (iRet != 0) {
		char	msg[MAX_MSG + 1];
		char	msg2[MAX_MSG + 1];

		LoadString(g_hinst, IDS_ERR_WRONG_ENCODING, msg, sizeof(msg));
		LoadString(g_hinst, IDS_QCONV_ERROR, msg2, sizeof(msg2));
		MessageBox(hMainDlg, msg, msg2, MB_OK);
		return 1;
	}

	iRet = InitializeNormalizer(hMainDlg);
	if (iRet != 0) {
		char	msg[MAX_MSG + 1];
		char	msg2[MAX_MSG + 1];

		LoadString(g_hinst, IDS_ERR_WRONG_NORMALIZER, msg, sizeof(msg));
		LoadString(g_hinst, IDS_QCONV_ERROR, msg2, sizeof(msg2));
		MessageBox(hMainDlg, msg, msg2, MB_OK);
		return 1;
	}

	QCSetWindowPos();

	return 0;
}

BOOL CALLBACK
SettingDlgProc(HWND hSetDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_INITDIALOG:
		SetSettingDlgItems(hSetDlg);
		break;

	case WM_DESTROY:
		break;

	case WM_COMMAND:
		switch (GET_WM_COMMAND_ID(wParam, lParam))
		{
		case IDCANCEL:
			EndDialog(hSetDlg, FALSE);
			break;

		case IDOK:
			if (GetSettingDlgItems(hSetDlg) == 0) {
				EndDialog(hSetDlg, TRUE);
			}
			break;

		case IDC_NORMALIZE:
			DialogBox(g_hinst, MAKEINTRESOURCE(IDD_NORMALIZE), hSetDlg, NormalizerDlgProc);
			break;

		case IDC_ABOUT:
			DialogBox(g_hinst, MAKEINTRESOURCE(IDD_ABOUT), hSetDlg, AboutDlgProc);
			break;

		case IDC_CONV_RACE:
		case IDC_CONV_UTF5:
		case IDC_CONV_UTF8:
		case IDC_CONV_OTHER:
		case IDC_ZLD_STRING:
		case IDC_SET_AUTO_ZLD:
		case IDC_SHOW_MAIN:
		case IDC_ALWAYS_ON_TOP:
		case IDC_RESULT_ONLY:
		case IDC_RESULT_AND_INPUT:
		case IDC_HEX_CODE:
		case IDC_MAX_MESSAGE_LEN:
		case IDC_SPIN_MESSAGE_LEN:
		case IDC_COPY_TO_CB:
		case IDC_ON_LEFT_CLICK:
		case IDC_CONTINUOUS:
			break;

		}
		break;

	default:
		return(FALSE);
	}

	return(TRUE);
}

BOOL CALLBACK
NormalizerDlgProc(HWND hNormalizerDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_INITDIALOG:
		SetNormalizerNames(hNormalizerDlg, id_normalizer);
		break;

	case WM_DESTROY:
		break;

	case WM_COMMAND:
		switch (GET_WM_COMMAND_ID(wParam, lParam))
		{
		case IDCANCEL:
			EndDialog(hNormalizerDlg, FALSE);
			break;

		case IDOK:
			GetNormalizerNames(hNormalizerDlg, id_normalizer);
			EndDialog(hNormalizerDlg, TRUE);
			break;

		}
		break;

	default:
		return(FALSE);
	}

	return(TRUE);
}

BOOL CALLBACK
AboutDlgProc(HWND hAboutDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_INITDIALOG:
		break;

	case WM_DESTROY:
		break;

	case WM_COMMAND:
		switch (GET_WM_COMMAND_ID(wParam, lParam))
		{
		case IDCANCEL:
			EndDialog(hAboutDlg, FALSE);
			break;

		case IDOK:
			EndDialog(hAboutDlg, TRUE);
			break;

		}
		break;

	default:
		return(FALSE);
	}

	return(TRUE);
}

BOOL
InitApplication(HINSTANCE hInstance)
{
        WNDCLASS    wc;
        BOOL resp;

        wc.style = 0;
        wc.lpfnWndProc = QConvDlgProc;
        wc.cbClsExtra = 0;
        wc.cbWndExtra = 0;
        wc.hInstance = hInstance;
        wc.hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON));
        wc.hCursor = LoadCursor(NULL, IDC_ARROW);
        wc.hbrBackground = NULL;
        wc.lpszClassName =  "QuickConverterClass";
        wc.lpszMenuName = NULL;

        resp = RegisterClass(&wc);

        return(resp);
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	g_hinst = hInstance;
    if (!hPrevInstance) {
        if (!InitApplication(hInstance)) {
            return(FALSE);
		}
	}

	DialogBox(hInstance, MAKEINTRESOURCE(IDD_DIALOGMAIN), NULL, QConvDlgProc);
	return(FALSE);
}
