/* "$Header: /mDNS/qconv/qconv.h 12    01/01/25 11:22 Kato $" */

/*
 * All of the documentation and software included in QCONV is copyrighted
 * by NTT Software Corporation.
 * 
 * Copyright 2000, 2001 NTT Software Corporation.  All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met: 
 * 
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE NTT SOFTWARE ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
 */

#define STRICT

#define _INC_OLE
#include <windows.h>
#undef  _INC_OLE

#include "resource.h"

#define	DEFAULT_ENCODING_NAME	"RACE"
#define	DEFAULT_EDIT_BUFFER_LEN	64				// Text size limit for Edit Control

#define	STR_NEWLINE				"\r\n"
#define	STR_NORMALIZER_DELIMTER	","

#define MYWM_NOTIFYICON			(WM_APP+100)

#define MAX_BUFFER				10240				// ClipBoard buffer
#define MAX_NORMALIZER_NAME		2048				// Normalizer name
#define MAX_MSG					256					// Message buffer
#define MAX_NAME				40					// Encoding name

#define MAX_NORMALIZER			20					// Numbers of normalizer scheme

#define	PRF_INPUT_ENCODING		"InputEncoding"		// IDC_INPUT_ENCODING
#define	PRF_OUTPUT_ENCODING		"OutputEncoding"	// IDC_OUTPUT_ENCODING
#define	PRF_OTHER_ENCODING		"OtherEncoding"		// IDC_CONV_OTHER
#define	PRF_LOCAL_ENCODING		"LocalEncoding"		// Read Only
#define	PRF_SHOW_MAIN			"ShowMain"			// IDC_SHOW_MAIN
#define	PRF_ZLD					"ZLD"				// IDC_ZLD_STRING
#define	PRF_AUTO_ZLD			"AutoZLD"			// IDC_SET_AUTO_ZLD
#define	PRF_NORMALIZER			"Normalizer"		// Normalizer Dialog
#define	PRF_COPY_TO_CLIPBOARD	"CopyToClipboard"	// IDC_COPY_TO_CB
#define PRF_ALWAYS_ON_TOP		"AlwaysOnTop"		// IDC_ALWAYS_ON_TOP
#define PRF_MAX_EDIT_BUFFER_LEN	"EditBufferLength"	// IDC_MAX_MESSAGE_LEN
#define PRF_RESULT_ONLY			"ResultOnly"		// IDC_RESULT_ONLY | IDC_RESULT_AND_INPUT
#define PRF_HEX_CODE			"DispHexCode"		// IDC_HEX_CODE
#define PRF_ON_LEFT_CLICK		"OnLeftClick"		// IDC_ON_LEFT_CLICK | IDC_CONTINUOUS
#define PRF_WINDOW_POS_X		"WindowPositionX"	// Window position X
#define PRF_WINDOW_POS_Y		"WindowPositionY"	// Window position X
#define PRF_DISABLE_ERROR		"DisableError"		// IDC_DISABLE_ERROR
#define PRF_NORMALIZER_ORDER	"NormalizerOrder"	// Read Only

#define SIZEOF_ENCODING_ETABLE		5

#define	GetMenuItemForName(name)	GetIDForString(encoding_table, SIZEOF_ENCODING_ETABLE, name)
#define	GetNameForMenuItem(id)		GetStringForID(encoding_table, SIZEOF_ENCODING_ETABLE, id)

typedef struct encoding_table {
	UINT	menu_item;
	UCHAR	name[MAX_NAME + 1];
	BOOL	flag;
}	ETABLE;

// qconv.c
extern HINSTANCE	g_hinst;

// maindlg.c
extern HWND			hMainDlg;

extern UCHAR		id_encoding_input[MAX_NAME + 1];		// IDC_INPUT_ENCODING
extern UCHAR		id_encoding[MAX_NAME + 1];				// IDC_OUTPUT_ENCODING
extern UCHAR		id_encoding_other[MAX_NAME + 1];		// IDC_CONV_OTHER
extern UCHAR		id_encoding_local[MAX_NAME + 1];		// Read Only
extern BOOL			id_show_main;							// IDC_SHOW_MAIN
extern UCHAR		id_zld[MAX_NAME + 1];					// IDC_ZLD_STRING
extern BOOL			id_auto_zld;							// IDC_SET_AUTO_ZLD
extern UCHAR		id_normalizer[MAX_NORMALIZER_NAME + 1];	// IDD_NORMALIZE
extern UCHAR		id_normalizer_order[MAX_NORMALIZER_NAME + 1];// Read Only
extern BOOL			id_copy_to_clipboard;					// IDC_COPY_TO_CB
extern BOOL			id_always_on_top;						// IDC_ALWAYS_ON_TOP
extern int			id_edit_buffer_len;						// IDC_MAX_MESSAGE_LEN
extern BOOL			id_result_only;							// IDC_RESULT_ONLY | IDC_RESULT_AND_INPUT
extern BOOL			id_disp_hex_code;						// IDC_HEX_CODE
extern BOOL			id_on_left_click;						// IDC_ON_LEFT_CLICK | IDC_CONTINUOUS
extern RECT			id_pos;									// Main Window Position
extern BOOL			id_disable_error;						// IDC_DISABLE_ERROR

extern ETABLE		encoding_table[];

// qconv.c
void			QCPopupMenu(HWND hDlg, LPARAM lParam);
BOOL CALLBACK	SettingDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK	NormalizerDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK	AboutDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);

// maindlg.c
BOOL CALLBACK	QConvDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
void			QCSetWindowPos(void);
BOOL			IsWindowsNT(void);

// clipboard.c
UCHAR			*StringCatAlloc(UCHAR *base, int *len, const UCHAR *str, BOOL newline);
void			AddMainMessage(UCHAR *message, BOOL newline);
void			AddErrorMessage(UCHAR *message, BOOL newline);
void			EraseMainMessage();
void			GetMainMessage();
void			ConvertClipBoard(HWND hDlg, const char *zld, int auto_zld);
int				InitializeConverter(void);
int				InitializeNormalizer(HWND hDlg);

// convert.c
int				convert_string(char *in_str, unsigned int, const char *zld, int auto_zld);
int				errmessage(FILE *fp, const char *format, ...);

// tray.c
BOOL			TrayMessage(HWND hDlg, DWORD dwMessage, HICON hIcon, PSTR pszTip);
void			SetTrayIcon(HWND hDlg);
LRESULT			IconDrawItem(LPDRAWITEMSTRUCT lpdi);

// misc.c
BOOL			IsTrueString(char *str);
UINT			GetIDForString(ETABLE *table, int size, UCHAR *name);
UCHAR			*GetStringForID(ETABLE *table, int size, UINT menu_item);
void			SetEncodingFromMenu(HWND hDlg, UINT return_id);
void			GetNormalizerNames(HWND hDlg, char *normalizer);
void			SetNormalizerNames(HWND hDlg, const char *normalizer);
int				AnalyzeNormalizerNames(const char *normalizer, char **NormalizerNames);
char			*GetDumpList(char *str);
void			AddMainLastErrorMessage(char *str);
char			*GetDefaultNormalizerOrder(void);
void			CheckNormalizerOrder(char *order, BOOL completion);

// util.c
int				initialize_converter(const char *in_code, const char *out_code,
								     const char *encoding_alias);
int				initialize_normalizer(char **normalizer, int nnormalizer);
